#!/usr/bin/perl -w

require '/var/smoothwall/header.pl';

my %pppsettings;

print "Content-type: text/html\n\n";

$pppsettings{'ACTION'} = '';
&getcgihash(\%pppsettings);

my $errormessage = '';

if ($pppsettings{'ACTION'} eq 'Save')
{
	if (!($pppsettings{'TELEPHONE'})) {
		$errormessage = 'Telephone not set.'; 
		goto ERROR; }
	if (!($pppsettings{'TELEPHONE'} =~ /^\d+$/)) {
		$errormessage = 'Only digits allowed in the telephone number field.';
		goto ERROR; }
	if (!($pppsettings{'USERNAME'})) {
		$errormessage = 'Username not set'; 
		goto ERROR; }
	if ($pppsettings{'USERNAME'} =~ / /) {
		$errormessage = 'Spaces not allowed in the username field.';
		goto ERROR; }
	if (!($pppsettings{'PASSWORD'})) {
		$errormessage = 'Password not set.';
		goto ERROR; }
	if ($pppsettings{'PASSWORD'} =~ / /) {
		$errormessage = 'Spaces not allowed in the password field.';
		goto ERROR; }

	if ($pppsettings{'LOGINSCRIPT'} =~ /[.\/ ]/ ) {
		$errormessage = 'Bad characters in script field.'; 
		goto ERROR; }

        if ($pppsettings{'DNS1'})
        {
                if (!($pppsettings{'DNS1'} =~ /^\d+\.\d+\.\d+\.\d+$/)) {
                        $errormessage = 'Invalid primary DNS.';
			goto ERROR;  }
        }
        if ($pppsettings{'DNS2'})
        {
                if (!($pppsettings{'DNS2'} =~ /^\d+\.\d+\.\d+\.\d+$/)) {
                        $errormessage = 'Invalid secondary DNS.';
			goto ERROR; }
        }

	if (!($pppsettings{'MAXRETRIES'})) {
		$errormessage = 'Max retries not set.';
		goto ERROR; }
	if (!($pppsettings{'MAXRETRIES'} =~ /^\d+$/)) {
		$errormessage = 'Only digits allowed in max retries field.';
		goto ERROR; }

ERROR:
	if ($errormessage) {
		$pppsettings{'VALID'} = 'no'; }
	else {
		$pppsettings{'VALID'} = 'yes'; }

	# write cgi vars to the file.
	&writehash("${swroot}/ppp/settings", \%pppsettings);

	# write secrets file.
	open(FILE, ">/${swroot}/ppp/secrets") or die "Unable to write secrets file";
	$username = $pppsettings{'USERNAME'};
	$password = $pppsettings{'PASSWORD'};
	print FILE "$username * $password\n";
	close FILE;
}

# read vars back from file.
&readhash("${swroot}/ppp/settings", \%pppsettings);

if (!($pppsettings{'VALID'}))
{
	$pppsettings{'STATE_ADVANCED'} = 0;
	$pppsettings{'DTERATE'} = 115200;
	$pppsettings{'PERSISTANT'} = 'off';
	$pppsettings{'MAXRETRIES'} = 10;
	$pppsettings{'DNS'} = 'Automatic';
}

$selected{'COMPORT'}{'ttyS0'} = '';
$selected{'COMPORT'}{'ttyS1'} = '';
$selected{'COMPORT'}{'ttyS2'} = '';
$selected{'COMPORT'}{'ttyS3'} = '';
$selected{'COMPORT'}{$pppsettings{'COMPORT'}} = 'SELECTED';

$checked{'USETIMEOUT'}{'off'} = '';
$checked{'USETIMEOUT'}{'on'} = '';
$checked{'USETIMEOUT'}{$pppsettings{'USETIMEOUT'}} = 'CHECKED';

$selected{'DTERATE'}{'9600'} = '';
$selected{'DTERATE'}{'19200'} = '';
$selected{'DTERATE'}{'38400'} = '';
$selected{'DTERATE'}{'57600'} = '';
$selected{'DTERATE'}{'115200'} = '';
$selected{'DTERATE'}{$pppsettings{'DTERATE'}} = 'SELECTED';

$selected{'AUTH'}{'pap-or-chap'} = '';
$selected{'AUTH'}{'standard-login-script'} = '';
$selected{'AUTH'}{'demon-login-script'} = '';
$selected{'AUTH'}{'other-login-script'} = '';
$selected{'AUTH'}{$pppsettings{'AUTH'}} = 'SELECTED';

$checked{'DNS'}{'Automatic'} = '';
$checked{'DNS'}{'Manual'} = '';
$checked{'DNS'}{$pppsettings{'DNS'}} = 'CHECKED';

$checked{'PERSISTANT'}{'off'} = '';
$checked{'PERSISTNAT'}{'on'} = '';
$checked{'PERSISTANT'}{$pppsettings{'PERSISTANT'}} = 'CHECKED';

&openpage("SmoothWall - PPP setup");

&openbigbox('100%', 'LEFT');

print "<FORM METHOD='POST'>\n";

&openbox('100%', 'LEFT', 'Telephony:');
print <<END
<TABLE WIDTH='100%'>
<TR><TD>Interface: </TD><TD>
<SELECT NAME='COMPORT'>
<OPTION VALUE='ttyS0' $selected{'COMPORT'}{'ttyS0'}>Modem on COM1
<OPTION VALUE='ttyS1' $selected{'COMPORT'}{'ttyS1'}>Modem on COM2
<OPTION VALUE='ttyS2' $selected{'COMPORT'}{'ttyS2'}>Modem on COM3
<OPTION VALUE='ttyS3' $selected{'COMPORT'}{'ttyS3'}>Modem on COM4
</SELECT>
</TD><TD>Number: </TD><TD>
<INPUT TYPE='text' NAME='TELEPHONE' VALUE='$pppsettings{'TELEPHONE'}'>
</TD></TR>
<TR><TD>Computer/Modem rate: </TD><TD COLSPAN='3'>
<SELECT NAME='DTERATE'>
<OPTION VALUE='9600' $selected{'DTERATE'}{'9600'}>9600
<OPTION VALUE='19200' $selected{'DTERATE'}{'19200'}>19200
<OPTION VALUE='38400' $selected{'DTERATE'}{'38400'}>38400
<OPTION VALUE='57600' $selected{'DTERATE'}{'57600'}>57600
<OPTION VALUE='115200' $selected{'DTERATE'}{'115200'}>115200
</SELECT>
</TD></TR>
<TR><TD>Persistant connection: </TD><TD>
<INPUT TYPE='checkbox' NAME='PERSISTANT' VALUE='on' $checked{'PERSISTANT'}{'on'}>
</TD><TD>Maximum retries: </TD><TD>
<INPUT TYPE='text' NAME='MAXRETRIES' VALUE='$pppsettings{'MAXRETRIES'}'>
</TD></TR>
</TABLE>
END
;

&closebox();

&openbox('100%', 'LEFT', 'Authentication:');
print <<END
<TABLE WIDTH='100%'>
<TR><TD>Username: </TD><TD>
<INPUT TYPE='text' NAME='USERNAME' VALUE='$pppsettings{'USERNAME'}'>
</TD><TD>Password: </TD><TD>
<INPUT TYPE='password' NAME='PASSWORD' VALUE='$pppsettings{'PASSWORD'}'>
</TD></TR>
<TR><TD>Method: </TD><TD>
<SELECT NAME='AUTH'>
<OPTION VALUE='pap-or-chap' $selected{'AUTH'}{'pap-or-chap'}>PAP or CHAP
<OPTION VALUE='standard-login-script' $selected{'AUTH'}{'standard-login-script'}>Standard login script
<OPTION VALUE='demon-login-script' $selected{'AUTH'}{'demon-login-script'}>Demon login script
<OPTION VALUE='other-login-script' $selected{'AUTH'}{'other-login-script'}>Other login script
</SELECT>
</TD><TD>Script name: </TD><TD>
<INPUT TYPE='text' NAME='LOGINSCRIPT' VALUE='$pppsettings{'LOGINSCRIPT'}'>
</TD></TR></TABLE>
END
;
&closebox();

&openbox('100%', 'LEFT', 'DNS:');
print <<END
<TABLE WIDTH='100%'>
<TR><TD>Type: </TD><TD COLSPAN=3>
<INPUT TYPE='radio' NAME='DNS' VALUE='Manual' $checked{'DNS'}{'Manual'}>Manual
<INPUT TYPE='radio' NAME='DNS' VALUE='Automatic' $checked{'DNS'}{'Automatic'}>Automatic
</TD></TR>
<TR><TD>Primary DNS: </TD><TD>
<INPUT TYPE='text' NAME='DNS1' VALUE='$pppsettings{'DNS1'}'>
</TD><TD>Secondary DNS: </TD><TD>
<INPUT TYPE='text' NAME='DNS2' VALUE='$pppsettings{'DNS2'}'>
</TD></TR></TABLE>
END
;
&closebox();
	
&openbox('100%', 'LEFT', 'Error messages:');
print "$errormessage";
print "&nbsp;";
&closebox();

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='80%'>
<TR>
<TD><INPUT TYPE='submit' NAME='ACTION' VALUE='Save'></TD>
<TD><INPUT TYPE='submit' NAME='ACTION' VALUE='Restore'></TD>
<TD><A HREF='/cgi-bin/index.cgi'>BACK</A></TD>
</TR></TABLE>
</DIV>
END
;

print "</FORM>";

&closebigbox();

&closepage();
