$|=1; # line buffering

$swroot = '/var/smoothwall';
$pagecolour = '#ffffff';
$bigboxcolour = '#e0ffff';
$boxcolour = '#c0ffff';

sub openpage
{
	$title = $_[0];

	print <<END
<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY BGCOLOR='$pagecolour'>
END
;
}

sub closepage
{
	print <<END
</BODY>
</HTML>
END
;
}

sub openbigbox
{
	$width = $_[0];
	$align = $_[1];

	print <<END
<TABLE WIDTH='$width' BORDER='0' BGCOLOR='$bigboxcolour' CELLPADDING='10'>
<TR><TD ALIGN='$align'>
END
;
}

sub closebigbox
{
	print "</TD></TR></TABLE>\n";
}

sub openbox
{
	$width = $_[0];
	$align = $_[1];
	$caption = $_[2];

	if ($caption) { print "<B>$caption</B>\n"; }

	print <<END
<TABLE WIDTH='$width' BORDER='0' BGCOLOR='$boxcolour' CELLPADDING='5'>
<TR><TD ALIGN='$align'>
END
;
}

sub closebox
{
	print "</TD></TR></TABLE><BR>\n";
}

sub writehash
{
	my $filename = $_[0];
	my $hash = $_[1];
	
	# write cgi vars to the file.
	open(FILE, ">${filename}") or die "Unable to write file $filename";

	foreach $var (keys %$hash) 
	{
		$val = $hash->{$var};
		if (!($var =~ /^ACTION/)) {
			print FILE "${var}=${val}\n"; }
	}
	close FILE;
}

sub readhash
{
	my $filename = $_[0];
	my $hash = $_[1];
	my ($var, $val);

	open(FILE, $filename) or die "Unable to read file $filename";
	
	while (<FILE>)
	{
		chop;
		($var, $val) = split /=/;
		if ($var) {
			$hash->{$var} = $val; }
	}
	close FILE;
}

sub getcgihash
{
	my $hash = $_[0];
	my $buffer = '';
	my $length = $ENV{'CONTENT_LENGTH'};
	my ($name, $value); 
	my ($pair, @pairs);
	my %hash;

	if ($ENV{'REQUEST_METHOD'} ne 'POST') {
		return; }

	read(STDIN, $buffer, $length);
	
	# Split the name-value pairs
	@pairs = split(/&/, $buffer);

	foreach $pair (@pairs)
	{
		($name, $value) = split(/=/, $pair);
		next unless $name; # fields MUST BE named!

		# Convert hex to ASCII
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
		$value =~ s/\+/ /g;

		# Strip out naughty characters -- this is a confusing line, huh?
		# Really it's just a list of characters allowed in the string.
		$value =~ s/[^\w\013\n!@#\$%\^\*()_\-\+=\{\}\[\]\\|;:\'\"<,>\.?\/`~ ]//g;
		$hash->{$name} = $value;
    }
    return %hash;
}
